%error = ForceRequiredAddOn( "Support_Doors" );
if(%error == $Error::AddOn_NotFound) {
	error( "PeekDoor Add-On : Support_Doors is a required add-on." );
	return;
}
function fxDTSBrick::getStringDirection(%this) {
	%northVector = "0 1 0";
	%southVector = "2.53518e-006 -1 0";
	%eastVector = "1 -3.69549e-006 0";
	%westVector = "-1 -3.69549e-006 0";
	%vec = %this.getForwardVector();
	if(%vec $= %northVector) return "North";
	if(%vec $= %southVector) return "South";
	if(%vec $= %eastVector) return "East";
	if(%vec $= %westVector) return "West";
}
function Player::getStringDirection(%this,%onlyTwo) {
	%xPos = getWord(%this.getForwardVector(),0);
	%yPos = getWord(%this.getForwardVector(),1);
	%half = "-0.711297";
	%half = "-0.50";
	if(%onlyTwo == 1) {
		// Only north and south.
		if(%yPos > 0) return "North";
		if(%yPos < 0) return "South";
		return "ERROR";
	}
	if(%onlyTwo == 2) {
		// Only east and west.
		if(%xPos > 0) return "East";
		if(%xPos < 0) return "West";
		return "ERROR";
	}
	if(%yPos < %half && %xPos > %half) return "South";
	if(getWord(%this.rotation,2) == -1 && getWord(%this.rotation,3) < 45 || getWord(%this.rotation,2) == 1 && getWord(%this.rotation,3) < 40) return "North";
	if(getWord(%this.rotation,2) == 1 && getWord(%this.rotation,3) > 150 && getWord(%this.rotation,2) == 1 && getWord(%this.rotation,3) < 228) return "South";
	if(getWord(%this.rotation,2) == 1 && getWord(%this.rotation,3) > 40 && getWord(%this.rotation,2) == 1 && getWord(%this.rotation,3) < 150) return "East";
	if(getWord(%this.rotation,2) == 1 && getWord(%this.rotation,3) > 228 || getWord(%this.rotation,2) == -1 && getWord(%this.rotation,3) > 45) return "West";
}
package PeekDoor {
	function fxDTSBrick::doorOpen(%this) {
		%obj = %this.peekingThrough;
		if(isObject(%obj)) {
			%obj.client.setControlObject(%obj);
			%obj.isPeekingThroughDoor = 0;
			%this.peekingThrough = "";
		}
		Parent::doorOpen(%this);
	}
	function Player::activateStuff(%this) {
		if(%this.isPeekingThroughDoor) {
			%this.client.setControlObject(%this);
			%this.isPeekingThroughDoor.peekingThrough = "";
			%this.isPeekingThroughDoor = 0;
			return;
		}
		%start = %this.getEyePoint();
		%eyeVec = %this.getEyeVector();
		%vector = VectorScale(%eyeVec, 100);
		%end = VectorAdd(%start, %vector);
		%mask = (((($TypeMasks::PlayerObjectType | $TypeMasks::StaticShapeObjectType) | $TypeMasks::StaticObjectType) | $TypeMasks::FxBrickAlwaysObjectType) | $TypeMasks::VehicleObjectType);
		%scanTarg = containerRayCast(%start, %end, %mask, %this);
		%pos = posFromRaycast(%scanTarg);
		%vec = VectorSub(%pos,%start);
		%scanTarg = getWord(%scanTarg,0);
		// Let's peek through some doors (if we can).
		if(!isObject(%scanTarg)) {
			Parent::activateStuff(%this);
			return;
		}
		if(%scanTarg.getClassName() !$= "fxDTSBrick") {
			Parent::activateStuff(%this);
			return;
		}
		if(!%scanTarg.getDatablock().isDoor || %scanTarg.getDatablock().isOpen) {
			Parent::activateStuff(%this);
			return;
		}
		if(!%this.isCrouched()) {
			Parent::activateStuff(%this);
			return;
		}
		if(VectorDist(%this.getPosition(),%scanTarg.getPosition()) > 4) {
			Parent::activateStuff(%this);
			return;
		}
		if(isObject(%scanTarg.peekingThrough))
			return;
		else
			%scanTarg.peekingThrough = "";

		%this.client.peekThroughDoor(%scanTarg);
	}
};
activatePackage(PeekDoor);
function GameConnection::peekThroughDoor(%this,%doorBrick) {
	%player = %this.player;
	%camera = %this.camera;
	if(!isObject(%player)) return;
	if(!isObject(%camera)) return;
	%doorBrick.peekingThrough = %this.player;
	%rot = getWords(%doorBrick.getTransform(),3,6);
	// Calculate offset

//	%fVec = %player.getForwardVector();
//	%fVec = round(getWord(%fVec,0)) SPC round(getWord(%fVec,1)) SPC round(getWord(%fVec,2));
//	%fVec = mClampF(getWord(%fVec,0),-0.25,0.25) SPC mClampF(getWord(%fVec,1),-0.25,0.25) SPC "0";
	%zPos = getWord(%doorBrick.getTransform(),2);
	//+brickToMetric(%doorBrick.getDatablock().brickSizeZ)/2/2;
	%dir = %doorBrick.getStringDirection();
	switch$(%dir) {
		case "North":
			// When you go north, your yPos becomes bigger.
			%eastOrWest = 0;
		case "South":
			%eastOrWest = 0;
		case "East":
			// When you go east, your xPos becomes bigger.
			%eastOrWest = 1;
		case "West":
			%eastOrWest = 1;
	}
	// 0 : East, north, south, or west
	// 1 : North or south
	// 2 : East or west
	if(%eastOrWest) {
		%dir = %player.getStringDirection(2);
		%yPos = "0";
		if(%dir $= "East") {
			%rot = "0 0 1 90";
			%xPos = "0.25";
		} else {
			%rot = "0 0 -1 90";
			%xPos = "-0.25";
		}
	} else {
		%dir = %player.getStringDirection(1);
		%xPos = "0";
		if(%dir $= "North") {
			%rot = "1 0 0 0";
			%yPos = "0.25";
		} else {
			%rot = "6 0 1 180";
			%yPos = "-0.25";
		}
	}
	%offset = %xPos SPC %yPos SPC %zPos;
	%offset = VectorAdd(getWords(%doorBrick.getTransform(),0,2),%offset);
	%offset = getWords(%offset,0,1) SPC %zPos;

	// Set the camera to it's position
	%this.setControlObject(%camera);
	%camera.setTransform(%offset SPC %rot);
	%camera.setOrbitPointMode(%offset SPC %rot,0);
	%player.isPeekingThroughDoor = %doorBrick;
}